Uses Crt;

Const VGA = $A000;

Type
    VScr = ^VirtScreen;
    VirtScreen = Array[1..64000] Of Byte;

    BarStuff = Record
           Pos,
           Test,
           Pal,
           Speed : Byte;
    end;

Var
   Loop,Loop1,Loop2,Loop3 : Word;
   VirScr : VScr;
   VirAddr : Word;
   Bars : Array[1..20] Of BarStuff;
   Test,NumB : Byte;

Procedure Gmode; Assembler;
asm
   mov ax,13h
   int 10h
end;

Procedure Tmode; Assembler;
asm
   mov ax,3h
   int 10h
end;

Procedure SetPal(Col,R,G,B : Byte);
Begin
     Port[$3c8] := Col;
     Port[$3c9] := R;
     Port[$3c9] := G;
     Port[$3c9] := B;
end;

Procedure Flip;
Begin
     Move(VirScr^,Mem[VGA:0],64000);
end;


Procedure PutPixel(X,Y : Word; Col : Byte; Where : Word);
Begin
     Mem[Where:Y*320+X] := Col;
end;


Procedure SetBars(NumBars,YPos : Word);
Var Num,PalType : Byte;
Begin
     Num := 0; PalType := 11;
     For loop := 1 To NumBars Do
     Begin
          Bars[Loop].Pos := Ypos+Num;
          Bars[Loop].Test := 0;
          Bars[loop].Pal := Loop*PalType;
          Bars[loop].Speed := 20;
          Inc(Num,44);
     end;
     NumB := Numbars;
end;

Procedure Logo;
Const Ball : Array[1..5,1..5] Of Byte =
      ((0,8,8,8,0),
       (8,8,19,8,8),
       (8,8,8,8,8),
       (8,8,8,8,8),
       (0,8,8,8,0));
Var Logo : Array[1..49] Of String;
    Logo1 : Array[1..10] Of String;
Begin
     Logo[1] := '  OOOOO   OOOOO   O   O   OOOOO  OOO   OOOO   O';
     Logo[2] := ' O        O   O   O   O  O        O   O    O  O';
     Logo[3] := ' O        OOOO    O   O  O        O   OOOOOO  O';
     Logo[4] := ' O        O   O   O   O  O        O   O    O  O';
     Logo[5] := '  OOOOO   O    O   OOO    OOOOO  OOO  O    O  OOOOO';

     Logo1[1] := 'OOOO ';
     Logo1[2] := 'O   O';
     Logo1[3] := 'O   O';
     Logo1[4] := 'O   O';
     Logo1[5] := 'OOOO ';

     For Loop := 1 To 5 Do
         For Loop1 := 1 To 49 Do
             If Logo[Loop][Loop1] = 'O' Then
                For Loop2 := 1 To 5 Do
                    For Loop3 := 1 To 5 Do
                        PutPixel(Loop1*6+Loop2,Loop*4+Loop3+70,Ball[Loop2,Loop3],Viraddr);

     For Loop := 1 To 5 Do
         For Loop1 := 1 To 49 Do
             If Logo1[Loop][Loop1] = 'O' Then
                For Loop2 := 1 To 5 Do
                    For Loop3 := 1 To 5 Do
                        PutPixel(Loop1*6+Loop2+130,Loop*4+Loop3+100,Ball[Loop2,Loop3],Viraddr);
end;


Procedure MoveBars;
Begin
     For loop2 := 1 To 10 Do
         For Loop := 1 To 319 Do
             For Loop1 := 1 To NumB Do
             PutPixel(Loop,Bars[Loop1].Pos+Loop2,Bars[Loop1].Pal-Loop2,Viraddr);
     Flip;
     FillChar(Virscr^,64000,0);
end;




Begin
     Tmode;
     Writeln('Crucial Development Presents A Copper Bar Routine By Darius Sutherland');
     Writeln('A Bit More Optimized Than The Last One 1 Day Ago.. This Routine Allows');
     Writeln('The Number Of Bars To Be Entered By Proc SetBars(Num) And Produces Them');
     Writeln('Palette Needs A Little Work And The Speed Also, If Speed Is Increased');
     Writeln('Then The Flicker Becomes Worse');
     Writeln; Writeln('03.12.95');
     Writeln('Added : 04.12.95 Crucial Development Logo With No Flicker Noticable');
     Readkey;
     Gmode;
     GetMem(VirScr,64000);
     VirAddr := Seg(VirScr^);
     FillChar(VirScr^,64000,0);

     For Loop := 1 To 5 Do SetPal(Loop,Loop+Loop+20,1,0);
     For Loop := 5 Downto 1 Do SetPal(11-Loop,Loop+Loop+20,1,0);

     For Loop := 11 To 16 Do SetPal(Loop,0,Loop+Loop+20,0);
     For Loop := 16 DownTo 11 Do SetPal(33-Loop,Loop,Loop+Loop+20,0);

     For Loop := 21 To 26 Do SetPal(Loop,0,0,Loop+Loop+40);
     For Loop := 26 DownTo 21 Do SetPal(53-Loop,0,0,Loop+Loop+40);



     SetBars(3,1);
     Test := 0;
     Repeat
           Logo;
           For Loop := 1 To NumB Do
           Begin
               If (Bars[Loop].Pos < 180) And (Bars[Loop].Test = 0) Then
               Begin
                    Bars[Loop].Speed := 10;
                    If Bars[Loop].Pos > 160 Then Bars[Loop].Speed := 4;
                    Inc(Bars[Loop].Pos,Bars[Loop].Speed);
                    If Bars[Loop].Pos > 180 Then Bars[Loop].Test := 1;
               end;

               If Bars[Loop].Test = 1 Then
               Begin
                    Bars[Loop].Speed := 10;
                    If Bars[Loop].Pos < 25 Then Bars[Loop].Speed := 4;
                    Dec(Bars[Loop].Pos,Bars[Loop].Speed);
                    If Bars[Loop].Pos < 10 Then Bars[Loop].Test := 0;
               end;
           end;

     MoveBars;
     Until KeyPressed;

     Flip; {Cls}
     Logo; Flip; For Loop := 1 To 40 Do Begin Delay(15);SetPal(Loop,Loop,Loop,Loop); End;
     Readkey;

     ReadKey; Tmode;
     Writeln('Well That Concludes the First Demo Affect By Darius Sutherland Crucial D');
     Writeln('Greets Goto :');
     Writeln('              Alex (Statix / PL) Evans');
     Writeln('              Grant Smith / AsphYxia');
     Writeln('              Mathew (Nemesis) Thomas');
end.



